﻿# UgcEquipmentExporter

A Unity plugin to zip UGC equipment models, metadata, and thumbnail images.
Verified to work on Unity2021.3.

<img src="UgcExporter.jpg" width="560">

### How to use

1. Launch the Unity Editor and open the GUI by navigating to "GensoMaker" -> "UGC Equipment Exporter" in the menu. 

2. Drag and drop the directory that contains the target asset into the area labeled [Drag & Drop the model asset directory HERE.]. 
(`Assets/GensoMakerUgc/sample_model` is the sample model.) The first fbx and texture found will be automatically set, you can select them again using the [Select] button if needed.

3. By pressing [Play attack motion], the attack motion will be played.

<img src="UgcExporter2.jpg" width="560">

4. Adjust the angle and position on the preview screen and capture the thumbnail by pressing the [Capture as thumbnail] button. 

5. Enter the metadata. See below. 

6. Click the [Validate & Export to zip] button to output a zip file. If there is a problem, an error will be displayed.


### Metadata

|Item Name|Content|
|:---|:---|
|Name English|Name(EN) 1-24 characters|
|Name Japanese|Name(JP) 1-12 characters *Can skip it|
|Name Trad.Chinese|Name(CH) 1-12 characters *Can skip it|
|Comment English|Comment(EN) 2-100 characters|
|Comment Japanese|Comment(JP) 1-50 characters *Can skip it|
|Comment Trad.Chinese|Comment(CH) 1-50 characters *Can skip it|
|Creator|Creator's Name 1-30 characters|
|Equip Slot|Equip Slot. *See below|

**Equip Slot**

|Item Name|Equipment Position|
|:---|:---|
| R-Hand |Right hand<br>Select weapon type (see below) with "Weapon Type". There are restrictions on the weapons that can be set.|
| L-Hand |Left hand<br>Select weapon type (see below) with "Weapon Type". There are restrictions on the weapons that can be set.|
| Head |Head|
| Body |Body (upper body)<br>Turn the pose On/Off with "Apply Pose" in the preview.|
| Leg |Legs (under body)<br>Turn the pose On/Off with "Apply Pose" in the preview.|
| Back |Back|
| Shoulder |Shoulder|

**Weapon Type**  
The motion during an attack will change.
Each weapon type has designated equipable slots.

|Item Name|Weapon|R-Hand|L-Hand|Remarks|
|:---|:---|:---|:---|:---|
|Sword| One-Handed Sword|✔|✔||
|Dagger | Dagger|✔|||
|Staff | Staff|✔|||
|Glove | Glove|✔|✔|Not Held|
|Gun | Gun|✔||
|Shield |Shield||✔||


**List of Errors**  
|Error|Content|
|:---|:---|
|Error:Please Input "〇〇〇"|Required field is missing.|
|Error:Too short "〇〇〇"|String is too short.|
|Error:Invalid characters used in "〇〇〇"|Invalid characters are used. Strings that appear to be phone numbers, email addresses, or URLs are included.|
|Error:Please Capture Thumbnail|No thumbnail image.|
|Error:Please Input Equip Slot|Equip Slot is not specified.|
|Error:Too many materials (N).Max:1|More than one Material is present.|
|Error:Too many polygons (N).Max:2000|Polygon count exceeds 2000.|
|Error:Too large model size(longest side)(N). Max:0.200|One side of the model is too large.|
|Error:Too large model size(sum of 3 sides)(N). Max:0.300|The total size of the three sides of the model is too large.|
|Error:Texture size too large (NxN).Max512x512|The size of the texture is larger than 512*512.|
|Error:Please Input FBX Path|No FBX file specified.|
|Error:Please Input Texture Path|No texture file specified.|
|Error:FBX not found|Can't find the specified FBX file.|
|Error:Texture not found|Can't find the specified texture file.|
|Error: Camera Detected in FBX | The FBX file should not include camera objects.|
|Error: Light Detected in FBX | The FBX file should not include light objects.|