﻿# UgcEquipmentExporter

UGC装備のモデル、メタデータ、サムネイル画像をzip化するUnityプラグイン。  
Unity2021.3で動作確認済み。

<img src="UgcExporter.jpg" width="560">

### 使い方

1. Unityエディタを起動し、メニューの「GensoMaker」→「UGC Equipment Exporter」でGUIを起動する。

2.  対象アセットが含まれるディレクトリを[Drag & Drop the model asset directory HERE.]と書かれたエリアにドラッグ＆ドロップする。  
(`Assets/GensoMakerUgc/sample_model` はサンプルモデル)  
最初に見つかったfbxとテクスチャが自動的に設定されるので、必要に応じて[Select]ボタンで選択し直す。

3.  [Play attack motion]を押すことで攻撃モーションが再生されます。

<img src="UgcExporter2.jpg" width="560">

4. プレビュー画面で角度や位置を調整し、[Capture as thumbnail]ボタンでサムネイルをキャプチャする。

5. メタデータを入力する。下記参照。

6. [Validate & Export to zip]ボタンをクリックすると、zipファイルが出力される。問題がある場合はエラーが表示される。


### メタデータ

|項目名|内容|
|:---|:---|
|Name English|アイテム名(英語) 1~24文字|
|Name Japanese|アイテム名(日本語) 1~12文字 ※省略可|
|Name Trad.Chinese|アイテム名(繁体字中国語) 1~12文字 ※省略可|
|Comment English|アイテム説明(英語) 2~100文字|
|Comment Japanese|アイテム説明(日本語) 1~50文字 ※省略可|
|Comment Trad.Chinese|アイテム説明(繁体字中国語) 1~50文字 ※省略可|
|Creator|製作者名 1~30文字|
|Equip Slot|装備スロット。※下記参照|

**Equip Slot(装備スロット)**

|項目名|装備位置|
|:---|:---|
| R-Hand |右手<br>"Weapon Type"で武器種(※下記)選択。設定可能武器に制限あり。|
| L-Hand |左手<br>"Weapon Type"で武器種(※下記)選択。設定可能武器に制限あり。|
| Head |頭|
| Body |胴(上半身)<br>プレビューの"Apply Pose"でポーズのOn/Off|
| Leg |脚(下半身)<br>プレビューの"Apply Pose"でポーズのOn/Off|
| Back |背中|
| Shoulder |肩|

**Weapon Type(武器種)**  
攻撃時のモーションが変化します。
武器種毎に指定可能な装備スロットが決まっています。

|項目名|武器|R-Hand|L-Hand|備考|
|:---|:---|:---|:---|:---|
|Sword| 片手剣|✔|✔||
|Dagger | 短剣|✔|||
|Staff | 杖|✔|||
|Glove | グローブ|✔|✔|手に握らない|
|Gun | 銃|✔|||
|Shield | 盾||✔||

**エラー内容一覧**  
|エラー|エラー内容|
|:---|:---|
|Error:Please Input "〇〇〇"|必須項目が未入力|
|Error:Too short "〇〇〇"|文字列が短すぎる|
|Error:Invalid characters used in "〇〇〇"|使用できない文字が使用されている。電話番号・メールアドレス・URLと思われる文字列が含まれている。|
|Error:Please Capture Thumbnail|サムネイル画像がない|
|Error:Please Input Equip Slot|Equip Slotが指定されていない|
|Error:Too many materials (N).Max:1|マテリアルが2つ以上ある|
|Error:Too many polygons (N).Max:2000|ポリゴン数が2000を超えている|
|Error:Too large model size(longest side)(N). Max:0.200|モデルの1辺のサイズが大きすぎる|
|Error:Too large model size(sum of 3 sides)(N). Max:0.300|モデルの3辺の合計サイズが大きすぎる|
|Error:Texture size too large (NxN).Max512x512|テクスチャのサイズが512*512よりも大きい|
|Error:Please Input FBX Path|FBXファイルが指定されていない|
|Error:Please Input Texture Path|テクスチャファイルが指定されていない|
|Error:FBX not found|指定されたFBXファイルが見つからない|
|Error:Texture not found|指定されたテクスチャファイルが見つからない|
|Error: Camera Detected in FBX|FBX内にカメラが含まれています|
|Error: Light Detected in FBX|FBX内にライトが含まれています|