﻿# UgcEquipmentExporter

能將UGC裝備模型、Metadata（詮釋資料）及縮圖壓縮為zip檔的Unity擴充功能。
已確認能在Unity2021.3版本中正常運行。

<img src="UgcExporter.jpg" width="560">

### 使用方式

1. 開啟Unity編輯器，點擊選單中的「GensoMaker」→「UGC Equipment Exporter」來啟動GUI。

2. 將含有目標Asset的目錄（Directory）拖曳至寫有[Drag & Drop the model asset directory HERE.]字樣的區域。
（`Assets/GensoMakerUgc/sample_model`為模型樣本）
系統會自動設定最先讀取到的fbx及紋理。如有需要，亦可點擊[Select]按鈕來重新選擇。

3. 此時只要點擊[Play attack motion]按鈕，即可播放攻擊動作。

<img src="UgcExporter2.jpg" width="560">

4. 在預覽畫面中調整角度或位置，並點擊[Capture as thumbnail]按鈕來擷取縮圖。

5. 輸入Metadata。請參照下方資訊。

6. 只要點選[Validate & Export to zip]按鈕，即可輸出zip檔案。如期間偵測到任何問題，則會跳出錯誤訊息。


### Metadata

|項目名稱|內容|
|:---|:---|
|Name English|道具名稱(英文) 1～24個字元。|
|Name Japanese|道具名稱(日文) 1～12個字。※可省略|
|Name Trad.Chinese|道具名稱(繁體中文) 1～12個字。※可省略|
|Comment English|道具說明(英文) 2～100個字元。|
|Comment Japanese|道具說明(日文) 1～50個字。※可省略|
|Comment Trad.Chinese|道具說明(繁體中文) 1～50個字。※可省略|
|Creator|製作者名稱 1～30個字。|
|Equip Slot|裝備欄位。※請參照下方資訊|

**Equip Slot(裝備欄位)**

|項目名稱|裝備位置|
|:---|:---|
| R-Hand |右手<br>於"Weapon Type"處選擇武器種類(見下方)。能設定的武器有一定限制。|
| L-Hand |左手<br>於"Weapon Type"處選擇武器種類(見下方)。能設定的武器有一定限制。|
| Head |頭|
| Body |身體(上半身)<br>可於預覽的"Apply Pose"處選擇姿勢On/Off|
| Leg |腿部(下半身)<br>可於預覽的"Apply Pose"處選擇姿勢On/Off|
| Back |背部|
| Shoulder |肩膀|

**Weapon Type(武器種類)**  
攻擊時的動作模組將產生變化。
個別武器種類能夠指定的裝備欄位都是固定的。

|項目名稱|武器|R-Hand|L-Hand|備註|
|:---|:---|:---|:---|:---|
|Sword| 單手劍|✔|✔||
|Dagger | 短劍|✔|||
|Staff | 法杖|✔|||
|Glove | 拳套|✔|✔|不以手握持|
|Gun | 火鎗|✔|||
|Shield | 盾牌||✔||

**錯誤內容一覽**  
|錯誤|錯誤內容|
|:---|:---|
|Error:Please Input "〇〇〇"|缺少必要資訊|
|Error:Too short "〇〇〇"|字串過短|
|Error:Invalid characters used in "〇〇〇"|包含了不可使用的文字。含有可能是電話號碼、電子信箱或網址的字串。|
|Error:Please Capture Thumbnail|缺少縮圖|
|Error:Please Input Equip Slot|未指定Equip Slot|
|Error:Too many materials (N).Max:1|含有超過兩份材質|
|Error:Too many polygons (N).Max:2000|面數超過2000|
|Error:Too large model size(longest side)(N). Max:0.200|模型單邊尺寸超出上限|
|Error:Too large model size(sum of 3 sides)(N). Max:0.300|模型三邊合計尺寸超出上限|
|Error:Texture size too large (NxN).Max512x512|紋理尺寸超過512*512|
|Error:Please Input FBX Path|未指定FBX資料|
|Error:Please Input Texture Path|未指定紋理資料|
|Error:FBX not found|找不到指定的FBX資料|
|Error:Texture not found|找不到指定的紋理資料|
|Error: Camera Detected in FBX|FBX資料不應包含Camera物件|
|Error: Light Detected in FBX|FBX資料不應包含Light物件料|